#!/usr/bin/env python3
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: stack.py 679 2014-06-24 13:57:18Z pieper $

class Stack(object): 
	"""
	Die Klasse Stack
	Objekte der Klasse Stack (Keller, Stapel) verwalten beliebige Objekte nach 
	dem Last-InFirst-Out-Prinzip, d.h., das zuletzt abgelegte Objekt wird als 
	erstes wieder entnommen.
	"""
	def __init__(self):
		"""Ein leerer Stapel wird erzeugt."""
		self._stack=list()

	def isEmpty(self):
		"""Die Anfrage liefert den Wert true, wenn der Stapel keine Objekte
		enthält, sonst liefert sie den Wert false."""
		return self._stack.__len__() == 0


	def push(self, pObject=None):
		"""Das Objekt pObject wird oben auf den Stapel gelegt. Falls pObject
		gleich null ist, bleibt der Stapel unverändert."""
		if pObject == None:
			return
		self._stack.insert(0,pObject)	
		

	def pop(self):
		"""Das zuletzt eingefügte Objekt wird von dem Stapel entfernt. Falls der
		Stapel leer ist, bleibt er unverändert."""
		if self.isEmpty():
			return
		else: 
			self._stack.remove(self.top())


	def top(self):
		"""Die Anfrage liefert das oberste Stapelobjekt. Der Stapel bleibt 
		unverändert. 
		Falls der Stapel leer ist, wird null zurück gegeben."""
		if self.isEmpty():
			return None
		else: 
			return self._stack[0]
			
			
	def __str__(self):	
		sys.stdout = x = ListStream()
		for elem in self._stack:
			print(str(elem),end="")
		sys.stdout = sys.__stdout__
		return str(x.data)
			

import sys
class ListStream:
    def __init__(self):
        self.data = ""
    def write(self, s):
        self.data+=s


if __name__ == "__main__":
	ueberschrift="Selbsttest der Klasse Stack\n"
	print (ueberschrift+(ueberschrift.__len__()-1)*"*")
	
	meinStaepelchen= Stack()
	
	print("push - Zehner")
	meinStaepelchen.push("ein Zehner")
	print("push - Zwanni")
	meinStaepelchen.push("ein Zwanni - ")
	print("push - Fuffi")
	meinStaepelchen.push("ein Fuffi - ")
	print("push - Hunni")
	meinStaepelchen.push("ein Hunni - ")
	
	print(meinStaepelchen)	
	
	print("top()",meinStaepelchen.top())
	print("pop()")
	meinStaepelchen.pop()
	print(meinStaepelchen)	


	while not meinStaepelchen.isEmpty():
		print("top()",meinStaepelchen.top())
		print("pop()")
		meinStaepelchen.pop()
		print(meinStaepelchen)
		
	



